from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, String, Boolean

Digestormotif_V0_1_0 = CommandToolBuilder(tool="DigestorMotif", base_command=["DigestorMotif"], inputs=[ToolInput(tag="in_in", input_type=File(optional=True), prefix="-in", doc=InputDocumentation(doc="*                 FASTA input file (valid formats: 'fasta')")), ToolInput(tag="in_out", input_type=File(optional=True), prefix="-out", doc=InputDocumentation(doc="*                Output file (peptides)\n(valid formats: 'idXML')")), ToolInput(tag="in_missed_cleavages", input_type=Int(optional=True), prefix="-missed_cleavages", doc=InputDocumentation(doc="The number of allowed missed cleavages (default: '1' min: '0')")), ToolInput(tag="in_mass_accuracy", input_type=Int(optional=True), prefix="-mass_accuracy", doc=InputDocumentation(doc="Give your mass accuracy in ppb (default: '1000')")), ToolInput(tag="in_min_length", input_type=Int(optional=True), prefix="-min_length", doc=InputDocumentation(doc="Minimum length of peptide (default: '6')")), ToolInput(tag="in_out_option", input_type=Int(optional=True), prefix="-out_option", doc=InputDocumentation(doc="Indicate 1 (peptide table only), 2 (statistics only) or (both peptide table + statistics) (default: '1')")), ToolInput(tag="in_enzyme", input_type=Int(optional=True), prefix="-enzyme", doc=InputDocumentation(doc="The enzyme used for peptide digestion. (default: 'Trypsin' valid: 'Glu-C+P', 'PepsinA + P', 'no cleavage', 'unspecific cleavage', 'Asp-N_ambic', 'Lys-C', 'CNBr', 'Formic_acid', 'Chymotrypsin', 'Chymotrypsin/P', 'TrypChymo', 'Trypsin/P', 'V8-DE', 'Asp-N', 'Asp-N/B', 'cyanogen-bromide', 'Clostripain/P', 'elastase-trypsin-chymotrypsin', 'V8-E', 'leukocyte elastase', 'proline endopeptidase', 'glutamyl endopeptidase', 'Alpha-lytic protease', '2-iodobenzoate', 'iodosobenzoate', 'staphylococcal protease/D', 'proline-endopeptidase/HKR', 'Trypsin', 'Lys-C/P', 'PepsinA', 'Arg-C', 'Arg-C/P', 'Lys-N')")), ToolInput(tag="in_motif", input_type=String(optional=True), prefix="-motif", doc=InputDocumentation(doc="The motif for the restricted peptidome (default: 'M')")), ToolInput(tag="in_ini", input_type=File(optional=True), prefix="-ini", doc=InputDocumentation(doc="Use the given TOPP INI file")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="-threads", doc=InputDocumentation(doc="Sets the number of threads allowed to be used by the TOPP tool (default: '1')")), ToolInput(tag="in_write_ini", input_type=File(optional=True), prefix="-write_ini", doc=InputDocumentation(doc="Writes the default configuration file")), ToolInput(tag="in_helphelp", input_type=Boolean(optional=True), prefix="--helphelp", doc=InputDocumentation(doc="Shows all options (including advanced)"))], outputs=[ToolOutput(tag="out_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="*                Output file (peptides)\n(valid formats: 'idXML')"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Digestormotif_V0_1_0().translate("wdl", allow_empty_container=True)

